jQuery(function($) {

    var current_payment_method;

    // 1 - Amplitude call when we change the payment method
    // 2 - Refresh the checkout to display discount at checkout
    var wc_checkout_form = {
        $checkout_form: $('form.woocommerce-checkout'),
        init: function () {
            // For the first call
            $(document.body).on('updated_checkout', this.do_update_checkout);

            // Payment method selection updated
            this.$checkout_form.on('change', 'input[name^="payment_method"]', this.trigger_update_payment_method);
        },
        do_update_checkout: function (event, args) {
            const payment_method_id = $("input[name='payment_method']:checked").val();
            const payment_method_label = $("label[for='payment_method_" + payment_method_id + "']").text().trim();

            current_payment_method = payment_method_id;

            // AMPLI : Send infos on payment method modification
            var data = {
                action: 'amplitude_action',
                step: 'change_payment_method',
                payment_method_id: payment_method_id,
                payment_method_label: payment_method_label
            };

            $.post(ajax_object.ajax_url, data); // jQuery.post
        },
        trigger_update_payment_method: function (event, args) {
            // Refresh the checkout
            $(document.body).trigger("update_checkout");
        },
    }

    var wc_handle_submission = {
        $checkout_form : $('form.woocommerce-checkout'),

        init: function () {
            // Fires button clic handle
            this.$checkout_form.on('checkout_place_order', this.do_handle_button);

            window.addEventListener("message", (event) => {
                if (!event.origin.includes("secure-payment.moona.com"))
                    return;
                
                var data = event.data;
                if (data.source !== "Moona") {
                    // console.log("Moona checkout: Wrong source");
                    return;
                } else {
                    // console.log("MOONA.JS");

                    switch (data.action) {
                        case "form-validation:valid":

                            // Keep the payload
                            this.$checkout_form.find('#moona_payload').val(JSON.stringify(data.payload));

                            // Deactivate the do_handle_button function event
	                        this.$checkout_form.off( 'checkout_place_order', this.do_handle_button );

                            // Submit the form
                            this.$checkout_form.submit();
                            break;
                        case "form-validation:errors":
                            // // let height = this.$checkout_form.find('#moona-integrated-container').height();
                            // height = 240 + (data.payload.errors.length * 20);
                            // // if (this.$checkout_form.find('#moona-integrated-container').css("height") != "300px") { 
                            //     this.$checkout_form.find('#moona-integrated-container').css('height', height + 'px');
                            //     this.$checkout_form.find('#moona-integrated-container > div').css('height', height + 'px');
                            // // }
                            break;
                        case "form-validation:no-error":
                            // if (this.$checkout_form.find('#moona-integrated-container').css("height") != "240px") { 
                            //     this.$checkout_form.find('#moona-integrated-container').css('height', '240px');
                            //     this.$checkout_form.find('#moona-integrated-container > div').css('height', '240px');
                            // }
                            break;
                        case "form:resize":
                            this.$checkout_form.find('#moona-integrated-container').css('height', data.payload.height);
                            this.$checkout_form.find('#moona-integrated-container > div').css('height', data.payload.height);
                            break;
                        default:
                            console.log("There is no response of Moona checkout API");
                    }
                }
            }, false);
        },

        do_handle_button: function () {
            if (current_payment_method === "discount-payment-main-moona") {
                // Send the click to the iframe and catch the click event to avoid to launch it now
                try {
                    const message = { action: 'cta:click', source: 'Moona' };
                    let moonaIframe = document.querySelector('#moona-form-integrated').contentWindow;
                    moonaIframe.postMessage(message, '*');
                } catch {
                    return false;
                }
                return false;
            } else {
                return true;
            }
        },
    }

    wc_handle_submission.init();
    wc_checkout_form.init();
});